<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;


class TiposRegistroBitacoraController extends Controller
{
    public function mostrarTodos(){
        $tiposRegistro = DB::table('bitacoras_tipos')->get();
        return response()->json($tiposRegistro);
    }

 public function crear(Request $request)
{
    try {
        DB::table('bitacoras_tipos')->insert([
            'idEscuela' => 'COLEGIOABC',
            'idBitacorasTipos' => $request->clave,
            'nombreBitacorasTipos' => $request->nombre,
            'esReporteBitacorasTipos' => $request->clasificar,
            'estado' => 'Activo',
        ]);

        return response()->json([
            'mensaje' => 'Tipo de registro creado correctamente'
        ], 200);

    } catch (\Exception $e) {
        return response()->json([
            'mensaje' => 'Error al crear el tipo de registro',
            'error'   => $e->getMessage() // 👈 aquí te muestra el error real
        ], 500);
    }
}

    public function editar(Request $request, $idBitacorasTipos){
       $idBitacorasTipos = base64_decode($idBitacorasTipos);
       $message = '';
       $status = 0;
       try{
              $tiposRegistro = DB::table('bitacoras_tipos')
              ->where('idBitacorasTipos', $idBitacorasTipos)
              ->update([
                'nombreBitacorasTipos' => $request->nombre,
                'esReporteBitacorasTipos' => $request->clasificar
              ]);
              $message = 'Tipo de registro actualizado correctamente'; $status = 200;
       }catch(\Exception $e){
           $message = 'Error al actualizar el tipo de registro'; $status = 500;
       }
         return response()->json(['mensaje' => $message], $status);
    }

    public function EliminarE($id){
       $id = base64_decode($id);
       $message= '';
       $status = 0;
       try{
              $tiposRegistro = DB::table('bitacoras_tipos')
              ->where('idBitacorasTipos', $id)
              ->Update([
                'estado' => 'Eliminado',
            ]);
            $message = 'Estado Eliminado correctamente'; $status = 200;

       }catch(\Exception $e){
           $message = 'Error al eliminar el tipo de registro'; $status = 500;
       }
    }

    public function HabilitarE($id){
        $id= base64_decode($id);
        $message = '';
        $status = 0;
        try{
            $tiposRegistro = DB::table('bitacoras_tipos')
            ->where('idBitacorasTipos', $id)
            ->Update([
                'estado' => 'Activo',
            ]);
            $message = 'Estado habilitado correctamente'; $status = 200;
        }catch(\Exception $e){
            $message = 'Error al habilitar el tipo de registro'; $status = 500;
        }
        return response()->json(['mensaje' => $message], $status);
    }
}
